// cmmc.h
//
// Contains preprocessor macro definitions for CMMC

// NMS-generated alarms (nc316.alr)
#define ALR_SCHEDSWOVR_SUCCESS    101
#define ALR_SCHEDSWOVR_FAILURE    102
#define ALR_SCHEDSWOVR_SKIPPED    103
#define ALR_SCHEDBACKUP_SUCCESS   104
#define ALR_SCHEDBACKUP_FAILURE   105
#define ALR_THRESHOLD_UNDER       110
#define ALR_THRESHOLD_ABOVE       111


//start Help defines
#define HELPID_CMIDENTIFY   230
#define HELPID_CMOSWSETUP   301
#define HELPID_CMOSWHIST    302
#define HELPID_CMARPTAB     305
#define HELPID_CMPING       716
#define HELPID_CMSWCONFIG   712
#define HELPID_CMEDTHST     724
#define HELPID_CMEUSMSLOT   759
#define HELPID_CMVLANCONF   760
#define HELPID_CMSYSINGIG  1012
#define HELPID_CMSMTP      1020
#define HELPID_CMSLREDUND  1110
#define HELPID_CMPOLINKS   1111
//#define HELPID_CMSLNVAREA  1111
#define HELPID_NTIDENTIFY  2230
#define HELPID_NTPING      2716
//end help defines


// IMPORTANT: if you change these constants, edit nc316.ini too
#define CMMC_MAXCHASSIS            3
#define CMMC_MAXCHASSISMINUSONE    2
#define CMMC_MAXSLOTS             16
#define CMMC_MAXSNR               48
#define CMMC_MAXSNRMINUSONE       47


#define CMMC_BUTTONPREV 1250
#define CMMC_BUTTONNEXT 1251


// In the LED files, each LED or bitmap that is dynamically
// displayed is assigned a row and columnar position within
// "var".  These are the position assignments.

// Slot-specific
#define LPOS_SLOTMNU       1
#define LPOS_SLOTPWR       2
#define LPOS_SLOTOPTYPE    3
#define LPOS_SLOTPWRLB    14
#define LPOS_SLOTBL       15   // Added July 02 for Bandwidth Limiter (211,212)
#define LPOS_SLOTINFO     49 
#define LPOS_SLOTLPBK     71
#define LPOS_SLOTNUMPORTS 98
#define LPOS_SLOTTYPEHASH 99
#define LPOS_SLOTNUMBER  100

// Port-specific
#define LPOS_PORTIMAGE    10
#define LPOS_RX           11
#define LPOS_TX           12
#define LPOS_ACTIVITY     13
#define LPOS_LPBKANY      14   // LPOS_SLOTLPBK preferred
#define LPOS_LPBKREMOTE   15
#define LPOS_LPBKLOCAL    16
#define LPOS_SELECTLINK   17
#define LPOS_SPEED        18   // Added June 2002 For card 246,247
#define LPOS_RNM          19   // Added August 2002 for RM family
#define LPOS_DUPLEX       20   // Added April 2003 for 314,315 EFAN boards



#define LPOS_SIGDETECT    23
#define LPOS_LINK         24
#define LPOS_PLL          25

#define LPOS_RNM          30

#define LPOS_ERROR        33
#define LPOS_COLLISION    33
#define LPOS_LOSSOFSIG    33
#define LPOS_ALARM        33
#define LPOS_SECTALRM     33
#define LPOS_RTSECTALRM   33

#define LPOS_SFPIMAGE     40
#define LPOS_SFPSPRES     41
#define LPOS_SFPRJLNK     42
#define LPOS_SFPRJRX      43



// Below are values used in the CMMC MIB.

// nbsCmmcPortLink
#define MIB_LINK_SD        3
#define MIB_LINK_LINK      4
#define MIB_LINK_PLL       5

// nbsCmmcPortLoopback
#define MIB_LOOPBACK_ON    3

//nbsCmmcPortRemoteLoopback
#define MIB_REMOTLPBK_ON   3

//nbsCmmcPortTxActivity
#define MIB_TX_ON          3

//nbsCmmcPortRxActivity
#define MIB_RX_ON          3

//nbsCmmcPortErrorActivity
#define MIB_ERROR_ON       3

//nbsCmmcPortCollisionActivity
#define MIB_COLLISION_ON   3

//nbsCmmcSlotOperationType
#define MIB_SLOTOP_SWITCH       5
#define MIB_SLOTOP_MULTICO_1G  32
#define MIB_SLOTOP_MULTICO_10G 33


#define LED_GREEN          1
#define LED_OFF            2
#define LED_RED            3
#define LED_YELLOW         4
#define LED_AMBER          4


// Definitions for different colors for each port status

// Black - nbsCmmcPortLink no-signal
#define PORT_DEAD          2 
// Green - nbsCmmcPortLink signal-detect
#define PORT_LIVE          3
 // Red   - used for loopback, maybe  
#define PORT_WARNING       6

#define NC316_BUOTHER      1
#define NC316_BU16         2
#define NC316_BU4          3
#define NC316_BU1          4
#define NC316_BU5          5
#define WL316_BU3          6
#define NC316_BU2          7
#define NC72              11
#define NC144             12
#define NC72_3G           17
#define NC288             18
#define NC316_BU3V        19
#define VIRTUAL_BU3V      20
#define NC36              21
#define CMMC_MAXCHASTYPE  21

// Maximum number of entries in CouSample database
#define CMCOUDBMAXRECS     2000
#define CMOSWDBMAXRECS     2000

#define CMOSA_CHANNELS    40
#define CMOSA_SIGPRESENT -60.0
#define OSW8_COMMONPORT    9
#define PORT_QSFP         219
#define PORT_CXP          220

// bytes in a float/double
#define SIZEOFFLOAT           8

//Port connectors defined in nbsCmmcPortConnector
#define MAX_PORT_CONNECTORS  36

//SlotOperationType defined in nbsCmmcSlotOperationType
#define MAX_SLOTOP_TYPE      39

// For EM316-RA12 (704)
// cmmc.crd must always have at least one entry beyond MAX_TYPES
// Entries must be added in all the three sections (Vertical, Horizontal & MCCs). EM316-RA12 (704)
#define  MAX_TYPES  704
// Entries must be added in all the three sections (Vertical, Horizontal & MCCs).EM316-RA12 (704)
// Entries must be added in all the three sections (Vertical, Horizontal & MCCs).EM316-RA12 (704)
// Entries must be added in all the three sections (Vertical, Horizontal & MCCs).EM316-RA12 (704)

// nbsCmmcSlotType
#define EM316_NM         56
#define EM316_OSA       586
#define EM316_GSWXY     568
#define EM316_OSW8      623
#define EM316_10GEUSM   595
#define EM316_EUSM      545
#define EM316DMR10G3R   661
#define EM316VOA8R      681
#define EM316VOA8L      682
#define EM316DVMDXA40MR 683
#define EM316_10G8SWXY1 628
#define EM316_10G8SWXY2 627
#define EM316_10G8SWXY3 626
#define EM316_RA12L     702
#define EM316_DT3E3     481
#define EMPMC_18DT3E3   533

// nbsCmmcSlotModuleType
 #define MODULE_10G8SWXY 626


#define CHAR_BACKSLASH  0x5C


//---- using of the "getTrapVars" command in the traps/alarms callback descriptors ---------------
 //
 //     var = getTrapVars(1|2|3|4|5|6|7);
 //
 //     1 = traps VarBind,
 //     2 = trap# from MIB and *.alr file,
 //     3 = log string after inserstion of the parameters,
 //     4 = severity1 : the alarm severity as it is defined by the user,
 //     5 = severity2 : the message severity (depends on the alarm_severity and the value if it has a value),
 //     6 = iptext of the source device,
 //     7 = alarm_index from *.alr file.
 //     8 = Text sender IP Address , but from pdu (v1 only, may not work)

// NMS_MAXFILENAMELENGTH is the length enforced by isFileNameCorrect(),.
// an extremely restrictive test intended to ensure the filename works
// on any platform.  It will fail perfectly valid filenames it doesn't
// like.  Developers can write a different filename checker using their
// own criteria.
#define NMS_MAXFILENAMELENGTH  16


#define TRAPVAR_VARBIND   1
#define TRAPVAR_TRAPNUM   2
#define TRAPVAR_LOGSTRING 3
#define TRAPVAR_SEVRUSER  4
#define TRAPVAR_SEVR2     5
#define TRAPVAR_IPTEXT    6
#define TRAPVAR_ALRINDEX  7
#define TRAPVAR_V1AGENTIP 8


// ASN.1 Identifiers (used by local.mib mibVarType)
#define BER_INTEGER       2
#define BER_BITSTRING     3
#define BER_OCTETSTRING   4
#define BER_NULL          5
#define BER_OID           6
#define BER_PRINTSTRING  19
#define BER_UTCTIME      23
#define BER_IPADDRESS    64
#define BER_COUNTER32    65
#define BER_GAUGE32      66
#define BER_TIMETICKS    67
#define BER_NSAPADDRESS  69
#define BER_COUNTER64    70
#define BER_UINTEGER32   71

// MV codes for getVarType()
//reg=getVarType(var); 2=INTEGER, 4=TEXT, 5=OCTSTRING  PhysAddr=7, IPADDR=64 ,IPADDR=1 | COUNTER=65 | GAUGE=66 | DOUBLE=73 | BIT_STR=3

#define VARTYPE_IPADDRINTEGER    1
#define VARTYPE_INTEGER          2
#define VARTYPE_BITSTRING        3
#define VARTYPE_TEXT             4
#define VARTYPE_OCTSTRING        5
#define VARTYPE_PHYSADDR         7
#define VARTYPE_IPADDROCTSTRING 64
#define VARTYPE_COUNTER         65
#define VARTYPE_GAUGE           66
#define VARTYPE_DOUBLE          73


// ifgraph.dsc has examples of graphs


/////////////////////////////////////////////////////////
extern "C" {
    void far _export serialComInit(void *pWindow ,void** par);
    void far _export serialSetIpDetails(void *pWindow ,void** par);
    void far _export serialGetIpDetails(void *pWindow ,void** par);
}
/////////////////////////////////////////////////////////
