#ifndef __SERSUPP_H
#define __SERSUPP_H

// Serial Communication supporting functions

#define SERIAL_COM_BUILD_NUMBER 101
#define SERIAL_COM_BUILD_DATE   "Oct-02-2003"

typedef struct {
    char ipAddress[16];
    char ipNetmask[16];
    char ipBroadcast[16];
    char ipGateway[16];
    char snmpReadCommunity[20];
    char snmpWriteCommunity[20];
} IpDetails;

int serialPortOpen (char* szPort, int iBaud);
int serialPortClose(void);
int sendAndExpect(char *ptrSend, char *ptrExpect);
int loginAs(char *userName, char *password);
int logout(void);
int getIpConfiguration(IpDetails *existingIpDetails);
int setIpConfiguration(IpDetails *existingIpDetails);
int setIpGateway(IpDetails *existingIpDetails);
int setSnmpCommunity(IpDetails *existingIpDetails);
int resetAndRecover(void);
int isValidIpAddress(char *inIpString);

void dbg_append (char* buf);           
void dbg_clear(void);                  
#endif // __SERSUPP_H
